.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

CodeSize MACRO algo
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s
  print str$(eax), 9, " bytes for &algo&", 13, 10
  popad
ENDM

.data
MyWords	label word
repeat 3000
dw 10000, 20000, 40000, 20000, 10000, 10000, 20000, 40000, 20000, 10000, 10000, 20000, 40000, 20000, 10000, 10000, 20000, 40000, 20000, 10000
endm

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000	; One Mio would be a typical value
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsA
		counter_end
		print str$(eax), 9, "cycles for AddWordsA", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsB
		counter_end
		print str$(eax), 9, "cycles for AddWordsB", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsC
		counter_end
		print str$(eax), 9, "cycles for AddWordsC", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsD
		counter_end
		print str$(eax), 9, "cycles for AddWordsD", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AddWordsF
		counter_end
		print str$(eax), 9, "cycles for AddWordsF", 13, 10
		
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AxAddWordsInt
		counter_end
		
		print str$(eax), 9, "cycles for AxAddWordInt", 13, 10
		
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AxAddWordsFPU1
		counter_end
		print str$(eax), 9, "cycles for AxAddWordsFPU1", 13, 10
		
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call AxAddWordsFPU2
		counter_end
		print str$(eax), 9, "cycles for AxAddWordsFPU2", 13, 10
		
		call AxAddWordsFPU1
		print str$(eax),9,"result for FPU1 code - should be 1200000000",13,10

		call AxAddWordsFPU2
		print str$(eax),9,"result for FPU2 code - should be 1200000000",13,10
		
		print chr$(13, 10)

	ENDM
	CodeSize AddWordsA
	CodeSize AddWordsB
	CodeSize AddWordsC
	CodeSize AddWordsD
	CodeSize AxAddWordsFPU1
	CodeSize AxAddWordsFPU2
	CodeSize AddWordsF
	CodeSize AxAddWordsInt
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

align 16
AddWordsA_s:
AddWordsA proc
	xor eax, eax
	ffree st(7)
	mov esi, offset MyWords
	push eax	; create a slot
	fldz
	m2m ecx, 60000
	.Repeat
		dec ecx
		movzx eax, word ptr [esi+2*ecx]
		mov [esp], eax
		fiadd dword ptr [esp]
	.Until Zero?
		if 0
		fistp dword ptr [esp]	; return result in eax, very slow
		pop eax
		else
		fstp st	; for testing, discard result in ST(0)
		pop eax
		endif
 ret
AddWordsA endp
AddWordsA_endp:

align 16
AddWordsB_s:
AddWordsB proc
	mov esi, offset MyWords
	push esi
	xor eax, eax
	ffree st(7)
	push eax	; zero the hiword
	fldz
	m2m ecx, 60000
	.Repeat
		lodsw
		mov [esp], eax
		fiadd dword ptr [esp]
		dec ecx
	.Until Zero?
	pop esi
	fistp dword ptr [esp]	; return result in eax, fast
	pop eax
  ret
AddWordsB endp
AddWordsB_endp:

align 16
AddWordsC_s:
AddWordsC proc
	mov esi, offset MyWords
	push esi
	xor eax, eax
	ffree st(7)
	push eax	; zero the hiword
	fldz
	lea ecx, [esi+60000*2]
	.Repeat
		lodsw
		mov [esp], eax
		fiadd dword ptr [esp]
	.Until esi>=ecx
	pop esi
	fistp dword ptr [esp]	; return result in eax
	pop eax
  ret
AddWordsC endp
AddWordsC_endp:

align 16
AddWordsD_s:
AddWordsD proc
	mov esi, offset MyWords
	ffree st(7)
	fldz
	m2m ecx, 60000
	.Repeat
		dec ecx
		fiadd word ptr [esi+2*ecx]	; will not yield correct results for unsigned words
	.Until Zero?
	fstp st
  ret
AddWordsD endp
AddWordsD_endp:

align 16
repeat 7
db 90h
endm
AxAddWordsFPU1_s:
AxAddWordsFPU1 proc
	mov esi, offset MyWords
	push eax
	push eax
	fldz
	@@:
	movzx edx,word ptr [esi]
	movzx ecx,word ptr [esi+2]
	lea esi,[esi+4]
	mov [esp],edx
	mov [esp+4],ecx
	cmp esi,offset MyWords+60000*2
					; unlimited number of words to addition
	fiadd dword ptr [esp]		; retuls are in EDX:EAX
	fiadd dword ptr [esp+4]
	jb @B
	fistp qword ptr [esp]
	pop eax
	pop edx
		
 ret
AxAddWordsFPU1 endp
AxAddWordsFPU1_endp:


align 16
repeat 7
db 90h
endm
AxAddWordsFPU2_s:
AxAddWordsFPU2 proc
	mov esi, offset MyWords
	push eax
	push eax
	fldz
	@@:
	movzx edx,word ptr [esi]
	movzx ecx,word ptr [esi+2]
	lea esi,[esi+4]
	mov [esp],edx
	mov [esp+4],ecx
	cmp esi,offset MyWords+60000*2
					; trying to use one fpu reg as MMX-like two
	fild qword ptr [esp]		; dwords reg, limitation of 131074 of words
	faddp st(1),st(0)		; to addition, possible corruption
	jb @B				; as well as very slow work with qwords
	fistp qword ptr [esp]
	pop eax
	pop edx
	add eax,edx
	mov edx,0
	adc edx,0
		
 ret
AxAddWordsFPU2 endp
AxAddWordsFPU2_endp:

align 16
AddWordsF_s:
AddWordsF proc

        push    60000/2
        mov     esi,offset MyWords
        xor     eax,eax
        pop     ecx

addwf0: mov     edx,[esi]
        movzx   ebx,dx
        add     eax,ebx
        shr     edx,16
        add     esi,4
        add     eax,edx
        dec     ecx
        jnz     addwf0

        ret

AddWordsF endp
AddWordsF_endp:


align 16
AxAddWordsInt_s:
repeat 6
db 90h
endm
AxAddWordsInt	proc

        mov     esi,offset MyWords

        mov eax,0
        
addwf0: movzx ecx,word ptr [esi]
        movzx edx,word ptr [esi+2]
        add eax,ecx
        lea esi,[esi+4]
        lea eax,[eax+edx]
        cmp esi,offset MyWords+60000*2
        jb     addwf0
        ret

AxAddWordsInt	endp
AxAddWordsInt_endp:

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]